# Class Composite

java.lang.Object
org.eclipse.swt.widgets.Widget
org.eclipse.swt.widgets.Control
org.eclipse.swt.widgets.Scrollable
org.eclipse.swt.widgets.Composite

All Implemented Interfaces:
  `Drawable`

Direct Known Subclasses:
  `AbstractFilteredViewerComposite, Browser, Canvas, CBanner, CCombo, Combo, CoolBar, CTabFolder, DateTime, DrillDownComposite, ExpandBar, FilteredList, Form, Group, HeapStatus, OleClientSite, OleFrame, PageBook, ProgressIndicator, ProgressMonitorPart, SashForm, ScrolledComposite, Spinner, TabFolder, Table, ToolBar, Tree, ViewForm`

public class Composite extends Scrollable
Instances of this class are controls which are capable of containing other controls.

Styles:
  NO_BACKGROUND, NO_FOCUS, NO_MERGE_PAINTS, NO_REDRAW_RESIZE, NO_RADIO_GROUP, EMBEDDED, DOUBLE_BUFFERED
Events:
  (none)

Note: The `NO_BACKGROUND`, `NO_FOCUS`, `NO_MERGE_PAINTS`, and `NO_REDRAW_RESIZE` styles are intended for use with `Canvas`. They can be used with `Composite` if you are drawing your own, but their behavior is undefined if they are used with subclasses of `Composite` other than `Canvas`.

Note: The `CENTER` style, although undefined for composites, has the same value as `EMBEDDED` which is used to embed widgets from other widget toolkits into SWT. On some operating systems (GTK), this may cause the children of this composite to be obscured.

This class may be subclassed by custom control implementors who are building controls that are constructed from aggregates of other controls.

See Also:
  - `Canvas`
  - Composite snippets
  - Sample code and further information

## Field Summary

### Fields inherited from class Control

`handle`

### Fields inherited from class Widget

`nativeZoom`

## Constructor Summary

Constructors
Constructor
Description
`Composite(Composite parent, int style)`
Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

## Method Summary

Modifier and Type
Method
Description
`void`
`changed(Control[] changed)`
Deprecated, for removal: This API element is subject to removal in a future version.
use `layout(Control[], int)` instead
`protected void`
`checkSubclass()`
Checks that this class can be subclassed.
`void`
`drawBackground(GC gc, int x, int y, int width, int height, int offsetX, int offsetY)`
Fills the interior of the rectangle specified by the arguments, with the receiver's background.
`int`
`getBackgroundMode()`
Returns the receiver's background drawing mode.
`Control[]`
`getChildren()`
Returns a (possibly empty) array containing the receiver's children.
`Layout`
`getLayout()`
Returns layout which is associated with the receiver, or null if one has not been set.
`boolean`
`getLayoutDeferred()`
Returns `true` if the receiver has deferred the performing of layout, and `false` otherwise.
`Control[]`
`getTabList()`
Gets the (possibly empty) tabbing order for the control.
`boolean`
`isLayoutDeferred()`
Returns `true` if the receiver or any ancestor up to and including the receiver's nearest ancestor shell has deferred the performing of layouts.
`void`
`layout()`
If the receiver has a layout, asks the layout to lay out (that is, set the size and location of) the receiver's children.
`void`
`layout(boolean changed)`
If the receiver has a layout, asks the layout to lay out (that is, set the size and location of) the receiver's children.
`void`
`layout(boolean changed, boolean all)`
If the receiver has a layout, asks the layout to lay out (that is, set the size and location of) the receiver's children.
`void`
`layout(Control[] changed)`
Forces a lay out (that is, sets the size and location) of all widgets that are in the parent hierarchy of the changed control up to and including the receiver.
`void`
`layout(Control[] changed, int flags)`
Forces a lay out (that is, sets the size and location) of all widgets that are in the parent hierarchy of the changed control up to and including the receiver.
`void`
`setBackgroundMode(int mode)`
Sets the background drawing mode to the argument which should be one of the following constants defined in class `SWT`: `INHERIT_NONE`, `INHERIT_DEFAULT`, `INHERIT_FORCE`.
`boolean`
`setFocus()`
Causes the receiver to have the keyboard focus, such that all keyboard events will be delivered to it.
`void`
`setLayout(Layout layout)`
Sets the layout which is associated with the receiver to be the argument which may be null.
`void`
`setLayoutDeferred(boolean defer)`
If the argument is `true`, causes subsequent layout operations in the receiver or any of its children to be ignored.
`void`
`setTabList(Control[] tabList)`
Sets the tabbing order for the specified controls to match the order that they occur in the argument list.
`String`
`toString()`
Returns a string containing a concise, human-readable description of the receiver.

### Methods inherited from class Scrollable

`computeTrim, getClientArea, getHorizontalBar, getScrollbarsMode, getVerticalBar, setScrollbarsMode`

### Methods inherited from class Control

`addControlListener, addDragDetectListener, addFocusListener, addGestureListener, addHelpListener, addKeyListener, addMenuDetectListener, addMouseListener, addMouseMoveListener, addMouseTrackListener, addMouseWheelListener, addPaintListener, addTouchListener, addTraverseListener, computeSize, computeSize, dragDetect, dragDetect, forceFocus, getAccessible, getBackground, getBackgroundImage, getBorderWidth, getBounds, getCursor, getData, getDragDetect, getEnabled, getFont, getForeground, getLayoutData, getLocation, getMenu, getMonitor, getOrientation, getParent, getRegion, getShell, getSize, getTextDirection, getToolTipText, getTouchEnabled, getVisible, internal_dispose_GC, internal_new_GC, isEnabled, isFocusControl, isReparentable, isVisible, moveAbove, moveBelow, pack, pack, print, redraw, redraw, removeControlListener, removeDragDetectListener, removeFocusListener, removeGestureListener, removeHelpListener, removeKeyListener, removeMenuDetectListener, removeMouseListener, removeMouseMoveListener, removeMouseTrackListener, removeMouseWheelListener, removePaintListener, removeTouchListener, removeTraverseListener, requestLayout, setAutoscalingMode, setBackground, setBackgroundImage, setBounds, setBounds, setCapture, setCursor, setData, setDragDetect, setEnabled, setFont, setForeground, setLayoutData, setLocation, setLocation, setMenu, setOrientation, setParent, setRedraw, setRegion, setSize, setSize, setTextDirection, setToolTipText, setTouchEnabled, setVisible, toControl, toControl, toDisplay, toDisplay, traverse, traverse, traverse, update`

### Methods inherited from class Widget

`addDisposeListener, addListener, addTypedListener, checkWidget, dispose, getData, getDisplay, getListeners, getStyle, getTypedListeners, isAutoDirection, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, removeListener, removeTypedListener, reskin, setData`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface Drawable

`isAutoScalable`

## Constructor Details

### Composite

public Composite(Composite parent, int style)
Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a widget which will be the parent of the new instance (cannot be null)
  `style` - the style of widget to construct
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
See Also:
  - `SWT.NO_BACKGROUND`
  - `SWT.NO_FOCUS`
  - `SWT.NO_MERGE_PAINTS`
  - `SWT.NO_REDRAW_RESIZE`
  - `SWT.NO_RADIO_GROUP`
  - `SWT.EMBEDDED`
  - `SWT.DOUBLE_BUFFERED`
  - `Widget.getStyle()`

## Method Details

### changed

@Deprecated(forRemoval=true, since="2026-09") public void changed(Control[] changed)
Deprecated, for removal: This API element is subject to removal in a future version.
use `layout(Control[], int)` instead
Clears any data that has been cached by a Layout for all widgets that are in the parent hierarchy of the changed control up to and including the receiver. If an ancestor does not have a layout, it is skipped.

Parameters:
  `changed` - an array of controls that changed state and require a recalculation of size
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the changed array is null any of its controls are null or have been disposed
  - ERROR_INVALID_PARENT - if any control in changed is not in the widget tree of the receiver
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.1

### checkSubclass

protected void checkSubclass()
Description copied from class: `Widget`
Checks that this class can be subclassed.

The SWT class library is intended to be subclassed only at specific, controlled points (most notably, `Composite` and `Canvas` when implementing new widgets). This method enforces this rule unless it is overridden.

IMPORTANT: By providing an implementation of this method that allows a subclass of a class which does not normally allow subclassing to be created, the implementer agrees to be fully responsible for the fact that any such subclass will likely fail between SWT releases and will be strongly platform specific. No support is provided for user-written classes which are implemented in this fashion.

The ability to subclass outside of the allowed SWT classes is intended purely to enable those not on the SWT development team to implement patches in order to get around specific limitations in advance of when those limitations can be addressed by the team. Subclassing should not be attempted without an intimate and detailed understanding of the hierarchy.

Overrides:
  `checkSubclass` in class `Widget`

### drawBackground

public void drawBackground(GC gc, int x, int y, int width, int height, int offsetX, int offsetY)
Fills the interior of the rectangle specified by the arguments, with the receiver's background.

The `offsetX` and `offsetY` are used to map from the `gc` origin to the origin of the parent image background. This is useful to ensure proper alignment of the image background.

Parameters:
  `gc` - the gc where the rectangle is to be filled
  `x` - the x coordinate of the rectangle to be filled
  `y` - the y coordinate of the rectangle to be filled
  `width` - the width of the rectangle to be filled
  `height` - the height of the rectangle to be filled
  `offsetX` - the image background x offset
  `offsetY` - the image background y offset
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the gc is null
  - ERROR_INVALID_ARGUMENT - if the gc has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.6

### getBackgroundMode

public int getBackgroundMode()
Returns the receiver's background drawing mode. This will be one of the following constants defined in class `SWT`: `INHERIT_NONE`, `INHERIT_DEFAULT`, `INHERIT_FORCE`.

Returns:
  the background mode
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.2
See Also:
  - `SWT`

### getChildren

public Control[] getChildren()
Returns a (possibly empty) array containing the receiver's children. Children are returned in the order that they are drawn. The topmost control appears at the beginning of the array. Subsequent controls draw beneath this control and appear later in the array.

Note: This is not the actual structure used by the receiver to maintain its list of children, so modifying the array will not affect the receiver.

Returns:
  an array of children
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `Control.moveAbove(Control)`
  - `Control.moveBelow(Control)`

### getLayout

public Layout getLayout()
Returns layout which is associated with the receiver, or null if one has not been set.

Returns:
  the receiver's layout or null
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getTabList

public Control[] getTabList()
Gets the (possibly empty) tabbing order for the control.

Returns:
  tabList the ordered list of controls representing the tab order
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `setTabList(Control[])`

### getLayoutDeferred

public boolean getLayoutDeferred()
Returns `true` if the receiver has deferred the performing of layout, and `false` otherwise.

Returns:
  the receiver's deferred layout state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.1
See Also:
  - `setLayoutDeferred(boolean)`
  - `isLayoutDeferred()`

### isLayoutDeferred

public boolean isLayoutDeferred()
Returns `true` if the receiver or any ancestor up to and including the receiver's nearest ancestor shell has deferred the performing of layouts. Otherwise, `false` is returned.

Returns:
  the receiver's deferred layout state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.1
See Also:
  - `setLayoutDeferred(boolean)`
  - `getLayoutDeferred()`

### layout

public void layout()
If the receiver has a layout, asks the layout to lay out (that is, set the size and location of) the receiver's children. If the receiver does not have a layout, do nothing.

Use of this method is discouraged since it is the least-efficient way to trigger a layout. The use of `layout(true)` discards all cached layout information, even from controls which have not changed. It is much more efficient to invoke `Control.requestLayout()` on every control which has changed in the layout than it is to invoke this method on the layout itself.

This is equivalent to calling `layout(true)`.

Note: Layout is different from painting. If a child is moved or resized such that an area in the parent is exposed, then the parent will paint. If no child is affected, the parent will not paint.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### layout

public void layout(boolean changed)
If the receiver has a layout, asks the layout to lay out (that is, set the size and location of) the receiver's children. If the argument is `true` the layout must not rely on any information it has cached about the immediate children. If it is `false` the layout may (potentially) optimize the work it is doing by assuming that none of the receiver's children has changed state since the last layout. If the receiver does not have a layout, do nothing.

It is normally more efficient to invoke `Control.requestLayout()` on every control which has changed in the layout than it is to invoke this method on the layout itself. Clients are encouraged to use `Control.requestLayout()` where possible instead of calling this method.

If a child is resized as a result of a call to layout, the resize event will invoke the layout of the child. The layout will cascade down through all child widgets in the receiver's widget tree until a child is encountered that does not resize. Note that a layout due to a resize will not flush any cached information (same as `layout(false)`).

Note: Layout is different from painting. If a child is moved or resized such that an area in the parent is exposed, then the parent will paint. If no child is affected, the parent will not paint.

Parameters:
  `changed` - `true` if the layout must flush its caches, and `false` otherwise
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### layout

public void layout(boolean changed, boolean all)
If the receiver has a layout, asks the layout to lay out (that is, set the size and location of) the receiver's children. If the changed argument is `true` the layout must not rely on any information it has cached about its children. If it is `false` the layout may (potentially) optimize the work it is doing by assuming that none of the receiver's children has changed state since the last layout. If the all argument is `true` the layout will cascade down through all child widgets in the receiver's widget tree, regardless of whether the child has changed size. The changed argument is applied to all layouts. If the all argument is `false`, the layout will not cascade down through all child widgets in the receiver's widget tree. However, if a child is resized as a result of a call to layout, the resize event will invoke the layout of the child. Note that a layout due to a resize will not flush any cached information (same as `layout(false)`).

It is normally more efficient to invoke `Control.requestLayout()` on every control which has changed in the layout than it is to invoke this method on the layout itself. Clients are encouraged to use `Control.requestLayout()` where possible instead of calling this method.

Note: Layout is different from painting. If a child is moved or resized such that an area in the parent is exposed, then the parent will paint. If no child is affected, the parent will not paint.

Parameters:
  `changed` - `true` if the layout must flush its caches, and `false` otherwise
  `all` - `true` if all children in the receiver's widget tree should be laid out, and `false` otherwise
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.1

### layout

public void layout(Control[] changed)
Forces a lay out (that is, sets the size and location) of all widgets that are in the parent hierarchy of the changed control up to and including the receiver. The layouts in the hierarchy must not rely on any information cached about the changed control or any of its ancestors. The layout may (potentially) optimize the work it is doing by assuming that none of the peers of the changed control have changed state since the last layout. If an ancestor does not have a layout, skip it.

It is normally more efficient to invoke `Control.requestLayout()` on every control which has changed in the layout than it is to invoke this method on the layout itself. Clients are encouraged to use `Control.requestLayout()` where possible instead of calling this method.

Note: Layout is different from painting. If a child is moved or resized such that an area in the parent is exposed, then the parent will paint. If no child is affected, the parent will not paint.

Parameters:
  `changed` - a control that has had a state change which requires a recalculation of its size
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the changed array is null any of its controls are null or have been disposed
  - ERROR_INVALID_PARENT - if any control in changed is not in the widget tree of the receiver
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.1

### layout

public void layout(Control[] changed, int flags)
Forces a lay out (that is, sets the size and location) of all widgets that are in the parent hierarchy of the changed control up to and including the receiver.

The parameter `flags` may be a combination of:

SWT.ALL
  all children in the receiver's widget tree should be laid out
SWT.CHANGED
  the layout must flush its caches
SWT.DEFER
  layout will be deferred

When the `changed` array is specified, the flags `SWT.ALL` and `SWT.CHANGED` have no effect. In this case, the layouts in the hierarchy must not rely on any information cached about the changed control or any of its ancestors. The layout may (potentially) optimize the work it is doing by assuming that none of the peers of the changed control have changed state since the last layout. If an ancestor does not have a layout, skip it.

When the `changed` array is not specified, the flag `SWT.ALL` indicates that the whole widget tree should be laid out. And the flag `SWT.CHANGED` indicates that the layouts should flush any cached information for all controls that are laid out.

The `SWT.DEFER` flag always causes the layout to be deferred by calling `Composite.setLayoutDeferred(true)` and scheduling a call to `Composite.setLayoutDeferred(false)`, which will happen when appropriate (usually before the next event is handled). When this flag is set, the application should not call `Composite.setLayoutDeferred(boolean)`.

Note: Layout is different from painting. If a child is moved or resized such that an area in the parent is exposed, then the parent will paint. If no child is affected, the parent will not paint.

Parameters:
  `changed` - a control that has had a state change which requires a recalculation of its size
  `flags` - the flags specifying how the layout should happen
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if any of the controls in changed is null or has been disposed
  - ERROR_INVALID_PARENT - if any control in changed is not in the widget tree of the receiver
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.6

### setBackgroundMode

public void setBackgroundMode(int mode)
Sets the background drawing mode to the argument which should be one of the following constants defined in class `SWT`: `INHERIT_NONE`, `INHERIT_DEFAULT`, `INHERIT_FORCE`.

Parameters:
  `mode` - the new background mode
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.2
See Also:
  - `SWT`

### setFocus

public boolean setFocus()
Description copied from class: `Control`
Causes the receiver to have the keyboard focus, such that all keyboard events will be delivered to it. Focus reassignment will respect applicable platform constraints.

Overrides:
  `setFocus` in class `Control`
Returns:
  `true` if the control got focus, and `false` if it was unable to.
See Also:
  - `Control.forceFocus()`

### setLayout

public void setLayout(Layout layout)
Sets the layout which is associated with the receiver to be the argument which may be null.

Parameters:
  `layout` - the receiver's new layout or null
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setLayoutDeferred

public void setLayoutDeferred(boolean defer)
If the argument is `true`, causes subsequent layout operations in the receiver or any of its children to be ignored. No layout of any kind can occur in the receiver or any of its children until the flag is set to false. Layout operations that occurred while the flag was `true` are remembered and when the flag is set to `false`, the layout operations are performed in an optimized manner. Nested calls to this method are stacked.

Parameters:
  `defer` - the new defer state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.1
See Also:
  - `layout(boolean)`
  - `layout(Control[])`

### setTabList

public void setTabList(Control[] tabList)
Sets the tabbing order for the specified controls to match the order that they occur in the argument list.

Parameters:
  `tabList` - the ordered list of controls representing the tab order or null
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if a widget in the tabList is null or has been disposed
  - ERROR_INVALID_PARENT - if widget in the tabList is not in the same widget tree
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### toString

public String toString()
Description copied from class: `Widget`
Returns a string containing a concise, human-readable description of the receiver.

Overrides:
  `toString` in class `Widget`
Returns:
  a string representation of the receiver